# Extensions

The following extensions are available globally.

### NSNumber

- `NSNumber`
  See more

  #### Declaration

  Swift

      extension NSNumber: CoreDataNativeType

      extension NSNumber: DefaultNSSecureCodable

      extension NSNumber: FieldStorableType

      extension NSNumber: ImportableAttributeType

      extension NSNumber: AllowedOptionalObjectiveCKeyPathValue

      extension NSNumber: AllowedObjectiveCAttributeKeyPathValue

      extension NSNumber: QueryableAttributeType

### NSString

- `NSString`
  See more

  #### Declaration

  Swift

      extension NSString: CoreDataNativeType

      extension NSString: CoreStoreDebugStringConvertible

      extension NSString: DefaultNSSecureCodable

      extension NSString: FieldStorableType

      extension NSString: ImportableAttributeType

      extension NSString: AllowedOptionalObjectiveCKeyPathValue

      extension NSString: AllowedObjectiveCAttributeKeyPathValue

      extension NSString: QueryableAttributeType

### NSDate

- `NSDate`
  See more

  #### Declaration

  Swift

      extension NSDate: CoreDataNativeType

      extension NSDate: DefaultNSSecureCodable

      extension NSDate: FieldStorableType

      extension NSDate: ImportableAttributeType

      extension NSDate: AllowedOptionalObjectiveCKeyPathValue

      extension NSDate: AllowedObjectiveCAttributeKeyPathValue

      extension NSDate: QueryableAttributeType

### NSData

- `NSData`
  See more

  #### Declaration

  Swift

      extension NSData: CoreDataNativeType

      extension NSData: DefaultNSSecureCodable

      extension NSData: FieldStorableType

      extension NSData: ImportableAttributeType

      extension NSData: AllowedOptionalObjectiveCKeyPathValue

      extension NSData: AllowedObjectiveCAttributeKeyPathValue

      extension NSData: QueryableAttributeType

### NSSet

- `NSSet`
  See more

  #### Declaration

  Swift

      extension NSSet: CoreDataNativeType

      extension NSSet: DefaultNSSecureCodable

      extension NSSet: AllowedOptionalObjectiveCKeyPathValue

      extension NSSet: AllowedObjectiveCRelationshipKeyPathValue

      extension NSSet: AllowedObjectiveCToManyRelationshipKeyPathValue

### NSOrderedSet

- `NSOrderedSet`
  See more

  #### Declaration

  Swift

      extension NSOrderedSet: CoreDataNativeType

      extension NSOrderedSet: AllowedOptionalObjectiveCKeyPathValue

      extension NSOrderedSet: AllowedObjectiveCRelationshipKeyPathValue

      extension NSOrderedSet: AllowedObjectiveCToManyRelationshipKeyPathValue

### NSManagedObject

- `NSManagedObject`
  See more

  #### Declaration

  Swift

      extension NSManagedObject: CoreDataNativeType

      extension NSManagedObject: DynamicObject

      extension NSManagedObject: AllowedOptionalObjectiveCKeyPathValue

      extension NSManagedObject: AllowedObjectiveCRelationshipKeyPathValue

      extension NSManagedObject: ObjectRepresentation

### NSManagedObjectID

- `NSManagedObjectID`
  See more

  #### Declaration

  Swift

      extension NSManagedObjectID: CoreDataNativeType

      extension NSManagedObjectID: CoreStoreDebugStringConvertible

      extension NSManagedObjectID: QueryableAttributeType

### NSNull

- `NSNull`
  See more

  #### Declaration

  Swift

      extension NSNull: CoreDataNativeType

      extension NSNull: DefaultNSSecureCodable

      extension NSNull: QueryableAttributeType

### Standard Types:

- `Array`
  See more

  #### Declaration

  Swift

      extension Array: CoreStoreDebugStringConvertible

      extension Array: FieldRelationshipType, FieldRelationshipToManyType, FieldRelationshipToManyOrderedType where Element: CoreStoreObject

- `Dictionary`

  #### Declaration

  Swift

      extension Dictionary: CoreStoreDebugStringConvertible

- `NSAttributeDescription`

  #### Declaration

  Swift

      extension NSAttributeDescription: CoreStoreDebugStringConvertible

- `NSAttributeType`
  See more

  #### Declaration

  Swift

      extension NSAttributeType: CoreStoreDebugStringConvertible

- `Bundle`

  #### Declaration

  Swift

      extension Bundle: CoreStoreDebugStringConvertible

- `NSDeleteRule`
  See more

  #### Declaration

  Swift

      extension NSDeleteRule: CoreStoreDebugStringConvertible

- `NSEntityDescription`

  #### Declaration

  Swift

      extension NSEntityDescription: CoreStoreDebugStringConvertible

- `NSError`

  #### Declaration

  Swift

      extension NSError: CoreStoreDebugStringConvertible

- `NSManagedObjectModel`

  #### Declaration

  Swift

      extension NSManagedObjectModel: CoreStoreDebugStringConvertible

- `NSMappingModel`

  #### Declaration

  Swift

      extension NSMappingModel: CoreStoreDebugStringConvertible

- `NSPredicate`

  #### Declaration

  Swift

      extension NSPredicate: CoreStoreDebugStringConvertible

- `NSRelationshipDescription`

  #### Declaration

  Swift

      extension NSRelationshipDescription: CoreStoreDebugStringConvertible

- `NSSortDescriptor`

  #### Declaration

  Swift

      extension NSSortDescriptor: CoreStoreDebugStringConvertible

- `NSURL`
  See more

  #### Declaration

  Swift

      extension NSURL: CoreStoreDebugStringConvertible

      extension NSURL: DefaultNSSecureCodable

      extension NSURL: FieldStorableType

      extension NSURL: ImportableAttributeType

      extension NSURL: AllowedOptionalObjectiveCKeyPathValue

      extension NSURL: AllowedObjectiveCAttributeKeyPathValue

      extension NSURL: QueryableAttributeType

- `Optional`
  See more

  #### Declaration

  Swift

      extension Optional: CoreStoreDebugStringConvertible

      extension Optional: FieldOptionalType

      extension Optional: FieldRelationshipType, FieldRelationshipToOneType where Wrapped: CoreStoreObject

      extension Optional: FieldStorableType where Wrapped: FieldStorableType

      extension Optional: AllowedObjectiveCKeyPathValue where Wrapped: AllowedOptionalObjectiveCKeyPathValue

      extension Optional: AllowedObjectiveCAttributeKeyPathValue where Wrapped: AllowedObjectiveCAttributeKeyPathValue, Wrapped: AllowedOptionalObjectiveCKeyPathValue

      extension Optional: AllowedOptionalObjectiveCKeyPathValue, AllowedObjectiveCRelationshipKeyPathValue where Wrapped: AllowedObjectiveCRelationshipKeyPathValue

      extension Optional: AllowedObjectiveCToManyRelationshipKeyPathValue where Wrapped: AllowedObjectiveCToManyRelationshipKeyPathValue, Wrapped: AllowedObjectiveCRelationshipKeyPathValue

- `Result`
  See more

  #### Declaration

  Swift

      extension Result: CoreStoreDebugStringConvertible

- `Selector`
  See more

  #### Declaration

  Swift

      extension Selector: CoreStoreDebugStringConvertible

- `String`
  See more

  #### Declaration

  Swift

      extension String: CoreStoreDebugStringConvertible

      extension String: FieldStorableType

      extension String: ImportableAttributeType

      extension String: AllowedOptionalObjectiveCKeyPathValue

      extension String: AllowedObjectiveCAttributeKeyPathValue

      extension String: QueryableAttributeType

- `URL`
  See more

  #### Declaration

  Swift

      extension URL: CoreStoreDebugStringConvertible

      extension URL: FieldStorableType

      extension URL: ImportableAttributeType

      extension URL: AllowedOptionalObjectiveCKeyPathValue

      extension URL: AllowedObjectiveCAttributeKeyPathValue

      extension URL: QueryableAttributeType

### KeyPathString

- `KeyPathString`
  See more

  #### Declaration

  Swift

      extension KeyPathString

### DiffableDataSource

- `DiffableDataSource`
  See more

### EnvironmentValues

- `EnvironmentValues`
  See more

  #### Declaration

  Swift

      extension EnvironmentValues

### Set: FieldRelationshipType, FieldRelationshipToManyType, FieldRelationshipToManyUnorderedType where Element: CoreStoreObject

- `Set`
  See more

  #### Declaration

  Swift

      extension Set: FieldRelationshipType, FieldRelationshipToManyType, FieldRelationshipToManyUnorderedType where Element: CoreStoreObject

### DefaultNSSecureCodable

- `NSArray`

  #### Declaration

  Swift

      extension NSArray: DefaultNSSecureCodable

- `NSDictionary`

  #### Declaration

  Swift

      extension NSDictionary: DefaultNSSecureCodable

      extension NSDictionary: SelectAttributesResultType

- `NSUUID`
  See more

  #### Declaration

  Swift

      extension NSUUID: DefaultNSSecureCodable

      extension NSUUID: FieldStorableType

      extension NSUUID: ImportableAttributeType

      extension NSUUID: AllowedOptionalObjectiveCKeyPathValue

      extension NSUUID: AllowedObjectiveCAttributeKeyPathValue

      extension NSUUID: QueryableAttributeType

### Bool

- `Bool`
  See more

  #### Declaration

  Swift

      extension Bool: FieldStorableType

      extension Bool: ImportableAttributeType

      extension Bool: AllowedObjectiveCKeyPathValue

      extension Bool: AllowedObjectiveCAttributeKeyPathValue

      extension Bool: QueryableAttributeType

### CGFloat

- `CGFloat`
  See more

  #### Declaration

  Swift

      extension CGFloat: FieldStorableType

      extension CGFloat: ImportableAttributeType

      extension CGFloat: AllowedObjectiveCKeyPathValue

      extension CGFloat: AllowedObjectiveCAttributeKeyPathValue

      extension CGFloat: QueryableAttributeType

### Data

- `Data`
  See more

  #### Declaration

  Swift

      extension Data: FieldStorableType

      extension Data: ImportableAttributeType

      extension Data: AllowedOptionalObjectiveCKeyPathValue

      extension Data: AllowedObjectiveCAttributeKeyPathValue

      extension Data: QueryableAttributeType

### Date

- `Date`
  See more

  #### Declaration

  Swift

      extension Date: FieldStorableType

      extension Date: ImportableAttributeType

      extension Date: AllowedOptionalObjectiveCKeyPathValue

      extension Date: AllowedObjectiveCAttributeKeyPathValue

      extension Date: QueryableAttributeType

### Double

- `Double`
  See more

  #### Declaration

  Swift

      extension Double: FieldStorableType

      extension Double: ImportableAttributeType

      extension Double: AllowedObjectiveCKeyPathValue

      extension Double: AllowedObjectiveCAttributeKeyPathValue

      extension Double: QueryableAttributeType

### Float

- `Float`
  See more

  #### Declaration

  Swift

      extension Float: FieldStorableType

      extension Float: ImportableAttributeType

      extension Float: AllowedObjectiveCKeyPathValue

      extension Float: AllowedObjectiveCAttributeKeyPathValue

      extension Float: QueryableAttributeType

### Int

- `Int`
  See more

  #### Declaration

  Swift

      extension Int: FieldStorableType

      extension Int: ImportableAttributeType

      extension Int: AllowedObjectiveCKeyPathValue

      extension Int: AllowedObjectiveCAttributeKeyPathValue

      extension Int: QueryableAttributeType

### Int8

- `Int8`
  See more

  #### Declaration

  Swift

      extension Int8: FieldStorableType

      extension Int8: ImportableAttributeType

      extension Int8: AllowedObjectiveCKeyPathValue

      extension Int8: AllowedObjectiveCAttributeKeyPathValue

      extension Int8: QueryableAttributeType

### Int16

- `Int16`
  See more

  #### Declaration

  Swift

      extension Int16: FieldStorableType

      extension Int16: ImportableAttributeType

      extension Int16: AllowedObjectiveCKeyPathValue

      extension Int16: AllowedObjectiveCAttributeKeyPathValue

      extension Int16: QueryableAttributeType

### Int32

- `Int32`
  See more

  #### Declaration

  Swift

      extension Int32: FieldStorableType

      extension Int32: ImportableAttributeType

      extension Int32: AllowedObjectiveCKeyPathValue

      extension Int32: AllowedObjectiveCAttributeKeyPathValue

      extension Int32: QueryableAttributeType

### Int64

- `Int64`
  See more

  #### Declaration

  Swift

      extension Int64: FieldStorableType

      extension Int64: ImportableAttributeType

      extension Int64: AllowedObjectiveCKeyPathValue

      extension Int64: AllowedObjectiveCAttributeKeyPathValue

      extension Int64: QueryableAttributeType

### UUID

- `UUID`
  See more

  #### Declaration

  Swift

      extension UUID: FieldStorableType

      extension UUID: ImportableAttributeType

      extension UUID: AllowedOptionalObjectiveCKeyPathValue

      extension UUID: AllowedObjectiveCAttributeKeyPathValue

      extension UUID: QueryableAttributeType

### ForEach

- `ForEach`
  See more

  #### Declaration

  Swift

      extension ForEach where Content: View

### RawRepresentable

- `RawRepresentable`
  See more

  #### Declaration

  Swift

      extension RawRepresentable where RawValue: ImportableAttributeType

### KeyPath: AnyKeyPathStringConvertible, KeyPathStringConvertible where Root: NSManagedObject, Value: AllowedObjectiveCKeyPathValue

- `KeyPath`
  See more

  #### Declaration

  Swift

      extension KeyPath: AnyKeyPathStringConvertible, KeyPathStringConvertible where Root: NSManagedObject, Value: AllowedObjectiveCKeyPathValue

      extension KeyPath where Root: NSManagedObject, Value: AllowedObjectiveCToManyRelationshipKeyPathValue

      extension KeyPath where Root: CoreStoreObject, Value: ToManyRelationshipKeyPathStringConvertible

### NSManagedObjectContext

- `NSManagedObjectContext`
  See more

  #### Declaration

  Swift

      extension NSManagedObjectContext: FetchableSource, QueryableSource

### Sequence where Iterator.Element: OrderByClause

- `Sequence`
  See more

  #### Declaration

  Swift

      extension Sequence where Iterator.Element: OrderByClause

      extension Sequence where Iterator.Element: WhereClauseType

### Progress

- `Progress`
  See more

  #### Declaration

  Swift

      extension Progress